import React, { useState, Component } from 'react';
import { Input } from '@alifd/next';
import type { Payload } from '@ywfe/yw-design';

interface DispatchSetterProps {
  defaultValue: Payload | null;
}
const DispatchSetter = (props: DispatchSetterProps) => {
  const { onChange, defaultValue } = props;
  const [value, setValue] = useState<Payload>(defaultValue);
  return (
    <div className="lc-dispatch-setter">
      {/* type */}
      <Input
        value={value?.type}
        placeholder="请输入事件类型"
        onChange={(val: any) => {
          setValue({ ...value, type: val });
          onChange({ ...value, type: val });
        }}
      />
      <Input
        value={value?.data}
        placeholder="请输入自定义参数"
        onChange={(val: any) => {
          console.log(123);
          setValue({ ...value, data: val });
          onChange({ ...value, data: val });
        }}
      />
    </div>
  );
};
DispatchSetter.defaultProps = {
  value: undefined,
  type: 'string',
  defaultValue: null,
  hasClear: true,
  onChange: () => undefined,
};
export default class extends Component<DispatchSetterProps> {
  render() {
    return <DispatchSetter {...this.props} />;
  }
}
