import React, { useState, Component, createElement } from 'react';
import { Select, Input } from '@alifd/next';

// 根据指定字段获取数据
interface valueProps {
  type: 'JSExpression' | 'JSFunction';
  value: string;
}
interface FieldSetterProps {
  // 获取数据函数模板
  template: string;
  // 默认字段
  defaultField: string;
  // 数据源
  data: valueProps;
  field: any;
  onChange: (val: string) => undefined;
}
// const tempPlaceHolder = '${rule}';
const tempPlaceHolderReg = /\$\{rule\}/g;
const valueReg = /\{"var":".*"\}/g;
const defaultTempFunc = 'this.appHelper?.utils?.jsonLogic(${rule},${data})';
const defaultTempHolderReg = /\$\{data\}/g;

const FieldSetter = (props: FieldSetterProps) => {
  const { onChange, field, data, template, defaultField = '' } = props;
  const _template = template || defaultTempFunc.replace(defaultTempHolderReg, data.value);
  const formatDefaultSetterVal = () => {
    const defaultValue = field.parent.getPropValue(field.name);
    if (defaultValue?.value) {
      const matchData = defaultValue.value.match(valueReg);
      console.log(JSON.parse(matchData[0]).var);
      if (matchData && matchData.length) {
        return JSON.parse(matchData[0]).var || defaultField;
      }
    }
    return defaultField;
  };
  const [value, setValue] = useState<string>(formatDefaultSetterVal());
  const items = [];
  const formatFieldVal = (rule) => {
    const func = _template.replace(tempPlaceHolderReg, JSON.stringify(rule));
    return {
      type: 'JSExpression',
      value: func,
    };
  };

  return (
    <div className="lc-field-setter">
      {items?.length ? (
        <Select
          value={value}
          style={{ width: '100%' }}
          placeholder="请选择字段"
          dataSource={items}
          onChange={(val: any) => {
            if (!val) return;
            const rules = { var: val };
            onChange(formatFieldVal(rules));
          }}
        />
      ) : (
        <Input
          style={{ width: '100%' }}
          value={value}
          onInput={(e) => {
            if (!e.target.value) return;
            const rules = { var: e.target.value };
            setValue(e.target.value);
            onChange(formatFieldVal(rules));
          }}
        />
      )}
    </div>
  );
};
FieldSetter.defaultProps = {
  value: undefined,
  type: 'string',
  defaultValue: null,
  hasClear: true,
  onChange: () => undefined,
};
export default class extends Component<FieldSetterProps> {
  render() {
    return <FieldSetter {...this.props} />;
  }
}
