import React, { useState, createElement, Component } from 'react';
import { Input } from '@alifd/next';

// 根据指定字段获取数据
interface valueProps {
  type: 'JSExpression' | 'JSFunction';
  value: string;
}
interface RuelsSetterProps {
  // 获取数据函数模板
  template: string;
  // 默认字段
  defaultField: string;
  // 数据源
  data: valueProps;
  field: any;
  onChange: (val: string) => undefined;
}
// const tempPlaceHolder = '${rule}';
const tempPlaceHolderReg = /\$\{rule\}/g;
const valueReg = /\{"var":".*"\}/g;
const defaultTempFunc = 'this.appHelper?.utils?.jsonLogic(${rule},${data})';
const defaultTempHolderReg = /\$\{data\}/g;

const RuelsSetter = (props: RuelsSetterProps) => {
  const { onChange, field, data, template, defaultField = '' } = props;
  const _template = template || defaultTempFunc.replace(defaultTempHolderReg, data.value);
  const formatDefaultSetterVal = () => {
    const defaultValue = field.parent.getPropValue(field.name);
    if (defaultValue?.value) {
      const matchData = defaultValue.value.match(valueReg);
      console.log(JSON.parse(matchData[0]).var);
      if (matchData && matchData.length) {
        return JSON.parse(matchData[0]).var || defaultField;
      }
    }
    return defaultField;
  };
  const [value, setValue] = useState<string>(formatDefaultSetterVal());
  // 接口获取 或者手动输入
  const formatFieldVal = (rule) => {
    const func = _template.replace(tempPlaceHolderReg, JSON.stringify(rule));
    return {
      type: 'JSExpression',
      value: func,
    };
  };

  return (
    <div className="lc-field-setter">
      <Input
        style={{ width: '100%' }}
        value={value}
        onInput={(e) => {
          if (!e.target.value) return;
          const rules = JSON.stringify(e.target.value);
          setValue(e.target.value);
          onChange(formatFieldVal(rules));
        }}
      />
    </div>
  );
};
RuelsSetter.defaultProps = {
  value: undefined,
  type: 'string',
  defaultValue: null,
  hasClear: true,
  onChange: () => undefined,
};
export default class extends Component<RuelsSetterProps> {
  render() {
    return <RuelsSetter {...this.props} />;
  }
}
