
import { IPublicTypeComponentMetadata, IPublicTypeSnippet } from '@alilc/lowcode-types';

const GroupMeta: IPublicTypeComponentMetadata = {
  componentName: 'Group',
  title: 'Group',
  group: '待定',
  docUrl: '',
  screenshot: '',
  devMode: 'proCode',
  npm: {
    package: '@ywfe/materials-design',
    version: '0.1.0',
    exportName: 'Button',
    main: 'src/index.tsx',
    destructuring: true,
    subName: 'Group',
  },
  configure: {
    props: [
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'size',
            'zh-CN': 'size',
          },
        },
        name: 'size',
        setter: {
          componentName: 'RadioGroupSetter',
          props: {
            dataSource: [
              {
                label: 'small',
                value: 'small',
              },
              {
                label: 'middle',
                value: 'middle',
              },
              {
                label: 'large',
                value: 'large',
              },
            ],
            options: [
              {
                label: 'small',
                value: 'small',
              },
              {
                label: 'middle',
                value: 'middle',
              },
              {
                label: 'large',
                value: 'large',
              },
            ],
          },
          initialValue: 'small',
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'prefixCls',
            'zh-CN': 'prefixCls',
          },
        },
        name: 'prefixCls',
        setter: {
          componentName: 'StringSetter',
          isRequired: false,
          initialValue: '',
        },
      },
    ],
    supports: {
      style: true,
      className: true,
    },
    component: {},
  },
};
const snippets: IPublicTypeSnippet[] = [
  {
    title: 'Group',
    screenshot: '',
    schema: {
      componentName: 'Group',
      props: {},
    },
  },
];

export default {
  ...GroupMeta,
  snippets,
};
