import { IPublicTypeComponentMetadata, IPublicTypeSnippet } from '@alilc/lowcode-types';

const PreviewListMeta: IPublicTypeComponentMetadata = {
  componentName: 'PreviewList',
  title: 'PreviewList',
  docUrl: '',
  group: '待定',
  screenshot: '',
  devMode: 'proCode',
  npm: {
    package: '@ywfe/materials-design',
    version: '0.0.1-beta.6',
    exportName: 'YwDrawerSelector',
    main: 'src/index.tsx',
    destructuring: true,
    subName: 'PreviewList',
  },
  configure: {
    props: [
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'dataSource',
            'zh-CN': 'dataSource',
          },
        },
        name: 'dataSource',
        setter: {
          componentName: 'ArraySetter',
          props: {
            itemSetter: {
              componentName: 'ObjectSetter',
              props: {
                config: {
                  items: [
                    {
                      title: {
                        label: {
                          type: 'i18n',
                          'en-US': 'itemNo',
                          'zh-CN': 'itemNo',
                        },
                      },
                      name: 'itemNo',
                      setter: {
                        componentName: 'MixedSetter',
                        props: {
                          setters: [
                            {
                              componentName: 'StringSetter',
                              isRequired: false,
                              initialValue: '',
                            },
                            {
                              componentName: 'NumberSetter',
                              isRequired: false,
                              initialValue: 0,
                            },
                          ],
                        },
                      },
                    },
                    {
                      title: {
                        label: {
                          type: 'i18n',
                          'en-US': 'itemImg',
                          'zh-CN': 'itemImg',
                        },
                      },
                      name: 'itemImg',
                      setter: {
                        componentName: 'StringSetter',
                        isRequired: false,
                        initialValue: '',
                      },
                    },
                  ],
                  extraSetter: {
                    componentName: 'MixedSetter',
                    isRequired: false,
                    props: {},
                  },
                },
              },
            },
          },
          initialValue: [],
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'pageSize',
            'zh-CN': 'pageSize',
          },
        },
        name: 'pageSize',
        setter: {
          componentName: 'NumberSetter',
          isRequired: false,
          initialValue: 0,
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'deleteItem',
            'zh-CN': 'deleteItem',
          },
        },
        name: 'deleteItem',
        setter: {
          componentName: 'FunctionSetter',
          isRequired: true,
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'rowKey',
            'zh-CN': 'rowKey',
          },
        },
        name: 'rowKey',
        setter: {
          componentName: 'MixedSetter',
          isRequired: true,
          props: {},
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'maxItems',
            'zh-CN': 'maxItems',
          },
        },
        name: 'maxItems',
        setter: {
          componentName: 'NumberSetter',
          isRequired: false,
          initialValue: 0,
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'setStyleBottom',
            'zh-CN': 'setStyleBottom',
          },
        },
        name: 'setStyleBottom',
        setter: {
          componentName: 'FunctionSetter',
          isRequired: true,
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'formatPreviewItemValue',
            'zh-CN': 'formatPreviewItemValue',
          },
        },
        name: 'formatPreviewItemValue',
        setter: {
          componentName: 'FunctionSetter',
          isRequired: true,
        },
      },
      {
        title: {
          label: {
            type: 'i18n',
            'en-US': 'renderMaxItemsMessageError',
            'zh-CN': 'renderMaxItemsMessageError',
          },
        },
        name: 'renderMaxItemsMessageError',
        setter: {
          componentName: 'FunctionSetter',
          isRequired: true,
        },
      },
    ],
    supports: {
      style: true,
    },
    component: {},
  },
};
const snippets: IPublicTypeSnippet[] = [
  {
    title: 'PreviewList',
    screenshot: '',
    schema: {
      componentName: 'PreviewList',
      props: {},
    },
  },
];

export default {
  ...PreviewListMeta,
  snippets,
};
