import { IPublicTypeComponentMetadata, IPublicTypeSnippet } from '@alilc/lowcode-types';

const TableTextMeta: IPublicTypeComponentMetadata = {
  componentName: 'TableText',
  title: '长文本',
  docUrl: '',
  screenshot: '',
  devMode: 'proCode',
  group: '基础组件',
  category: '表格子元素',
  npm: {
    package: '@ywfe/materials-design',
    version: '0.1.0',
    exportName: 'TableText',
    main: 'src/index.tsx',
    destructuring: true,
    subName: '',
  },
  configure: {
    props: [
      {
        name: 'row',
        title: { label: '文本省略', tip: 'row | 超过指定行数省略' },
        setter: 'NumberSetter',
        defaultValue: 2,
      },
      {
        name: 'tooltip',
        title: { label: '悬浮提示', tip: 'tooltip | 悬浮提示' },
        setter: 'BoolSetter',
        defaultValue: true,
      },
      {
        name: 'isCopy',
        title: { label: '可复制', tip: 'isCopy | 文案可复制' },
        setter: 'BoolSetter',
        defaultValue: true,
      },
      {
        name: 'onClick',
        title: { label: '可点击', tip: 'onClick | 可点击' },
        setter: 'FunctionSetter',
        defaultValue: undefined,
      },
    ],
    supports: {
      style: true,
    },
    component: {},
  },
};
const snippets: IPublicTypeSnippet[] = [
  {
    title: '长文本',
    screenshot: 'https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/lowcode/longtext',
    schema: {
      componentName: 'TableText',
      props: {
        tooltip: true,
        value: {
          type: 'JSExpression',
          value: 'this.text',
        },
      },
    },
  },
];

export default {
  ...TableTextMeta,
  snippets,
};
