
import { IPublicTypeComponentMetadata, IPublicTypeSnippet } from '@alilc/lowcode-types';

const YwContainerMeta: IPublicTypeComponentMetadata = {
  componentName: 'YwContainer',
  title: 'YwContainer',
  group: '待定',
  docUrl: '',
  screenshot: '',
  devMode: 'proCode',
  npm: {
    package: '@ywfe/materials-design',
    version: '0.1.0-beta.2',
    exportName: 'YwContainer',
    main: 'src/index.tsx',
    destructuring: true,
    subName: '',
  },
  configure: {
    props: [
      {
        title: {
          label: '联动逻辑',
          tip: 'linkages | 联动逻辑',
        },
        name: 'linkages',
        description: '联动逻辑',
        setter: {
          componentName: 'ArraySetter',
          props: {
            itemSetter: {
              componentName: 'ObjectSetter',
              props: {
                config: {
                  extraSetter: {
                    componentName: 'MixedSetter',
                    isRequired: false,
                    props: {},
                  },
                },
              },
              isRequired: false,
              initialValue: {},
            },
          },
          initialValue: [],
        },
      },
      {
        title: {
          label: '加载状态',
          tip: 'loading | 加载状态',
        },
        name: 'loading',
        description: '加载状态',
        setter: {
          componentName: 'BoolSetter',
          isRequired: false,
          initialValue: false,
        },
      },
      {
        title: {
          label: '数据错误',
          tip: 'error | 数据错误',
        },
        name: 'error',
        description: '数据错误',
        setter: {
          componentName: 'BoolSetter',
          isRequired: false,
          initialValue: false,
        },
      },
      {
        title: {
          label: '数据为空',
          tip: 'empty | 数据为空',
        },
        name: 'empty',
        description: '数据为空',
        setter: {
          componentName: 'BoolSetter',
          isRequired: false,
          initialValue: false,
        },
      },
      {
        title: {
          label: '标题',
          tip: 'title | 标题',
        },
        name: 'title',
        description: '标题',
        setter: {
          componentName: 'StringSetter',
          isRequired: false,
          initialValue: '',
        },
      },
    ],
    supports: {
      style: true,
      className: true,
    },
    component: {
      isContainer: true,
    },
  },
};
const snippets: IPublicTypeSnippet[] = [
  {
    title: 'YwContainer',
    screenshot: '',
    schema: {
      componentName: 'YwContainer',
      props: {},
    },
  },
];

export default {
  ...YwContainerMeta,
  snippets,
};
