import { IPublicTypeFieldConfig } from '@alilc/lowcode-types';
export declare const customComponentProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    supportVariable: boolean;
    defaultValue: any;
    setter: {
        componentName: string;
        title: string;
        hideParams: boolean;
        initialValue: {
            type: string;
            params: string[];
            value: any[];
        };
    };
    condition: (target: any) => boolean;
};
export declare const sizeConfig: {
    name: string;
    title: {
        label: string;
        tip: string;
    };
    setter: {
        componentName: string;
        props: {
            options: {
                label: string;
                value: string;
            }[];
        };
    };
    defaultValue: string;
};
export declare const layoutConfig: {
    items: {
        name: string;
        title: {
            label: string;
            tip: string;
        };
        setter: {
            componentName: string;
            initialValue: number;
        };
    }[];
};
export declare const descriptionProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
    supportVariable: boolean;
};
export declare const defaultValueProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: {
        componentName: string;
        props: {
            setters: string[];
        };
    };
};
export declare const readOnlyProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
    supportVariable: boolean;
};
export declare const requiredProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
    supportVariable: boolean;
};
export declare const disabledProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
};
export declare const previewProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
    condition: (target: any) => boolean;
};
export declare const rulesProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: {
        componentName: string;
    };
    supportVariable: boolean;
};
export declare const decoratorProps: {
    name: string;
    title: {
        label: string;
        tip: string;
    };
    defaultValue: string;
    setter: {
        componentName: string;
        props: {
            options: {
                label: string;
                value: string;
            }[];
        };
    };
    supportVariable: boolean;
};
export declare const propsProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    display: string;
    setter: {
        componentName: string;
        props: {
            config: {
                items: ({
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    propType: string;
                    setter: string;
                    supportVariable: boolean;
                } | {
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    propType: string;
                    setter: {
                        componentName: string;
                        props: {
                            options: {
                                label: string;
                                value: string;
                            }[];
                        };
                    };
                    supportVariable: boolean;
                } | {
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: string;
                    supportVariable: boolean;
                    propType?: undefined;
                } | {
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: {
                        componentName: string;
                        props: {
                            options: {
                                label: string;
                                value: string;
                            }[];
                        };
                    };
                    supportVariable: boolean;
                    propType?: undefined;
                })[];
            };
        };
    };
    supportVariable: boolean;
    condition: (target: any) => boolean;
};
export declare const getDataSourceProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    supportVariable: boolean;
    setter: (target: any) => {
        componentName: string;
        props: {
            setters: {
                componentName: string;
                props: {
                    title: string;
                    async: boolean;
                    properties: {};
                };
            }[];
        };
    };
};
export declare const componentPropsProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    display: string;
    extraProps: {
        defaultCollapsed: boolean;
    };
    supportVariable: boolean;
    setter: {
        componentName: string;
        props: {
            config: {
                items: ({
                    condition: (target: any) => boolean;
                } | {
                    title: {
                        label: string;
                        tip: string;
                    };
                    name: string;
                    setter: {
                        componentName: string;
                    };
                    supportVariable: boolean;
                } | {
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: string;
                    supportVariable: boolean;
                })[];
            };
            defaultValue: {};
        };
    };
};
export declare const reactionsProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: {
        componentName: string;
    };
    supportVariable: boolean;
};
export declare const visibleProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    supportVariable: boolean;
    setter: string[];
};
export declare const childrenProps: {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: {
        componentName: string;
    };
    supportVariable: boolean;
    condition: (target: any) => boolean;
};
export declare const arrayTableItemsProps: {
    type: string;
    setter: {
        componentName: string;
        props: {
            config: {
                items: {
                    name: string;
                    condition: boolean;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: {
                        componentName: string;
                        props: {
                            itemSetter: {
                                componentName: string;
                                props: {
                                    config: {
                                        items: ({
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            supportVariable: boolean;
                                            defaultValue: any;
                                            setter: {
                                                componentName: string;
                                                title: string;
                                                hideParams: boolean;
                                                initialValue: {
                                                    type: string;
                                                    params: string[];
                                                    value: any[];
                                                };
                                            };
                                            condition: (target: any) => boolean;
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            display: string;
                                            defaultValue: string;
                                            isRequired: boolean;
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                            };
                                            important: boolean;
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            important: boolean;
                                            supportVariable: boolean;
                                            defaultValue: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    setters: ({
                                                        componentName: string;
                                                        props?: undefined;
                                                    } | {
                                                        componentName: string;
                                                        props: {
                                                            options: any;
                                                            showSearch: boolean;
                                                        };
                                                    })[];
                                                };
                                            };
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    options: {
                                                        label: string;
                                                        value: string;
                                                    }[];
                                                };
                                                initialValue: string;
                                            };
                                            extraProps: {
                                                setValue: (target: any, value: any) => void;
                                            };
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    setters: string[];
                                                };
                                            };
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            setter: string;
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            defaultValue: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    options: {
                                                        label: string;
                                                        value: string;
                                                    }[];
                                                };
                                            };
                                            supportVariable: boolean;
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            display: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    config: {
                                                        items: ({
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            propType: string;
                                                            setter: string;
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            propType: string;
                                                            setter: {
                                                                componentName: string;
                                                                props: {
                                                                    options: {
                                                                        label: string;
                                                                        value: string;
                                                                    }[];
                                                                };
                                                            };
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: string;
                                                            supportVariable: boolean;
                                                            propType?: undefined;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: {
                                                                componentName: string;
                                                                props: {
                                                                    options: {
                                                                        label: string;
                                                                        value: string;
                                                                    }[];
                                                                };
                                                            };
                                                            supportVariable: boolean;
                                                            propType?: undefined;
                                                        })[];
                                                    };
                                                };
                                            };
                                            supportVariable: boolean;
                                            condition: (target: any) => boolean;
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            display: string;
                                            extraProps: {
                                                defaultCollapsed: boolean;
                                            };
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    config: {
                                                        items: ({
                                                            condition: (target: any) => boolean;
                                                        } | {
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            name: string;
                                                            setter: {
                                                                componentName: string;
                                                            };
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: string;
                                                            supportVariable: boolean;
                                                        })[];
                                                    };
                                                    defaultValue: {};
                                                };
                                            };
                                        })[];
                                    };
                                };
                                initialValue: {
                                    title: string;
                                    name: string;
                                    component: string;
                                    props: {
                                        feedbackLayout: string;
                                    };
                                };
                            };
                        };
                    };
                }[];
            };
        };
    };
    extraProps: {
        setValue: (target: any, value?: any[]) => {
            type: string;
            component: string;
            decorator: string;
            componentProps: {
                title: any;
                align: string;
                width: any;
            };
            children: any[];
        }[];
    };
    condition: (target: any) => boolean;
};
export declare const arrayItemsItemsProps: {
    type: string;
    setter: {
        componentName: string;
        props: {
            config: {
                items: {
                    name: string;
                    condition: boolean;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: {
                        componentName: string;
                        props: {
                            itemSetter: {
                                componentName: string;
                                props: {
                                    config: {
                                        items: ({
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            display: string;
                                            defaultValue: string;
                                            isRequired: boolean;
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                            };
                                            important: boolean;
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            important: boolean;
                                            supportVariable: boolean;
                                            defaultValue: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    setters: ({
                                                        componentName: string;
                                                        props?: undefined;
                                                    } | {
                                                        componentName: string;
                                                        props: {
                                                            options: any;
                                                            showSearch: boolean;
                                                        };
                                                    })[];
                                                };
                                            };
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    options: {
                                                        label: string;
                                                        value: string;
                                                    }[];
                                                };
                                                initialValue: string;
                                            };
                                            extraProps: {
                                                setValue: (target: any, value: any) => void;
                                            };
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    setters: string[];
                                                };
                                            };
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            setter: string;
                                        } | {
                                            name: string;
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            defaultValue: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    options: {
                                                        label: string;
                                                        value: string;
                                                    }[];
                                                };
                                            };
                                            supportVariable: boolean;
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            display: string;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    config: {
                                                        items: ({
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            propType: string;
                                                            setter: string;
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            propType: string;
                                                            setter: {
                                                                componentName: string;
                                                                props: {
                                                                    options: {
                                                                        label: string;
                                                                        value: string;
                                                                    }[];
                                                                };
                                                            };
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: string;
                                                            supportVariable: boolean;
                                                            propType?: undefined;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: {
                                                                componentName: string;
                                                                props: {
                                                                    options: {
                                                                        label: string;
                                                                        value: string;
                                                                    }[];
                                                                };
                                                            };
                                                            supportVariable: boolean;
                                                            propType?: undefined;
                                                        })[];
                                                    };
                                                };
                                            };
                                            supportVariable: boolean;
                                            condition: (target: any) => boolean;
                                        } | {
                                            title: {
                                                label: string;
                                                tip: string;
                                            };
                                            name: string;
                                            display: string;
                                            extraProps: {
                                                defaultCollapsed: boolean;
                                            };
                                            supportVariable: boolean;
                                            setter: {
                                                componentName: string;
                                                props: {
                                                    config: {
                                                        items: ({
                                                            condition: (target: any) => boolean;
                                                        } | {
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            name: string;
                                                            setter: {
                                                                componentName: string;
                                                            };
                                                            supportVariable: boolean;
                                                        } | {
                                                            name: string;
                                                            title: {
                                                                label: string;
                                                                tip: string;
                                                            };
                                                            setter: string;
                                                            supportVariable: boolean;
                                                        })[];
                                                    };
                                                    defaultValue: {};
                                                };
                                            };
                                        })[];
                                    };
                                };
                                initialValue: {
                                    name: string;
                                    component: string;
                                    props: {
                                        feedbackLayout: string;
                                    };
                                };
                            };
                        };
                    };
                }[];
            };
        };
    };
    extraProps: {
        setValue: (target: any, value?: any[]) => void;
    };
    condition: (target: any) => boolean;
};
export declare const BaseFormItemProps: ({
    name: string;
    title: {
        label: string;
        tip: string;
    };
    display: string;
    defaultValue: string;
    isRequired: boolean;
    supportVariable: boolean;
    setter: {
        componentName: string;
    };
    important: boolean;
} | {
    name: string;
    title: {
        label: string;
        tip: string;
    };
    important: boolean;
    supportVariable: boolean;
    defaultValue: string;
    setter: {
        componentName: string;
        props: {
            setters: ({
                componentName: string;
                props?: undefined;
            } | {
                componentName: string;
                props: {
                    options: any;
                    showSearch: boolean;
                };
            })[];
        };
    };
} | {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    setter: string;
    supportVariable: boolean;
} | {
    title: {
        label: string;
        tip: string;
    };
    name: string;
    display: string;
    extraProps: {
        defaultCollapsed: boolean;
    };
    supportVariable: boolean;
    setter: {
        componentName: string;
        props: {
            config: {
                items: ({
                    condition: (target: any) => boolean;
                } | {
                    title: {
                        label: string;
                        tip: string;
                    };
                    name: string;
                    setter: {
                        componentName: string;
                    };
                    supportVariable: boolean;
                } | {
                    name: string;
                    title: {
                        label: string;
                        tip: string;
                    };
                    setter: string;
                    supportVariable: boolean;
                })[];
            };
            defaultValue: {};
        };
    };
} | {
    title: string;
    type: string;
    display: string;
    extraProps: {
        defaultCollapsed: boolean;
    };
    items: ({
        title: {
            label: string;
            tip: string;
        };
        name: string;
        setter: {
            componentName: string;
            props: {
                setters: string[];
            };
        };
    } | {
        title: {
            label: string;
            tip: string;
        };
        name: string;
        setter: string;
    } | {
        title: {
            label: string;
            tip: string;
        };
        name: string;
        setter: {
            componentName: string;
        };
        supportVariable: boolean;
    } | {
        title: {
            label: string;
            tip: string;
        };
        name: string;
        supportVariable: boolean;
        setter: string[];
    })[];
} | {
    title: string;
    type: string;
    display: string;
    items: any[];
    extraProps?: undefined;
})[];
export declare const tableFormItemProps: any[];
export declare const FormItemsProps: IPublicTypeFieldConfig[];
