"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _base = require("../_base");
var _utils = require("../_utils");
var DataAddDialogMeta = {
  componentName: 'DataAddDialog',
  title: '新增数据',
  docUrl: '',
  screenshot: '',
  group: '页面模块',
  category: '数据操作',
  devMode: 'proCode',
  npm: {
    "package": '@ywfe/materials-design',
    version: '0.0.1-beta.6',
    exportName: 'YwFormDialog',
    main: 'src/index.tsx',
    destructuring: true,
    subName: ''
  },
  configure: {
    props: [{
      name: 'ref',
      title: {
        label: '组件标识',
        tip: "ref | 通过 this.$('xxx') 获取到组件实例"
      },
      defaultValue: function defaultValue() {
        return "data_add_dialog_" + (0, _utils.uuid)();
      },
      setter: 'StringSetter'
    }, {
      name: 'title',
      title: {
        label: '弹窗标题',
        tip: 'title | 标题'
      },
      setter: 'StringSetter'
    }].concat(_base.YwButtonBaseProps, _base.FormItemsProps, [{
      title: {
        label: '表单默认值',
        tip: 'initialValues | 表单默认值'
      },
      display: 'inline',
      name: 'initialValues',
      description: '表单默认值',
      setter: {
        componentName: 'JsonSetter',
        isRequired: false,
        initialValue: {}
      }
    }, {
      title: {
        label: '确定操作',
        tip: 'onConfirm | 确定操作'
      },
      name: 'onConfirm',
      setter: function setter(target) {
        var ref = (0, _utils.getPropValueWithPath)(target, '.ref');
        return {
          componentName: 'SchemaFunctionSetter',
          props: {
            title: 'getDataSource',
            async: true,
            properties: {
              input: {
                type: 'object',
                properties: {
                  values: {
                    type: 'string'
                  }
                },
                required: ['values']
              },
              body: {
                type: 'array',
                items: [{
                  type: 'Function',
                  properties: {
                    template: 'RequestFunction',
                    variable: 'requestRes',
                    extraProps: {
                      params: '{{values}}'
                    }
                  }
                }, {
                  type: 'JSExpression',
                  run: 'if (requestRes) this.reload && this.reload()'
                }, {
                  type: 'Function',
                  properties: {
                    template: 'DispatchFunction',
                    extraProps: {
                      path: ref,
                      type: 'add',
                      data: '{{undefined}}'
                    }
                  }
                }]
              },
              output: 'requestRes'
            }
          }
        };
      }
    }]),
    supports: {
      events: [{
        name: 'onConfirm',
        description: '确认事件'
      }, {
        name: 'onCancel',
        description: '取消事件',
        template: 'function onCancel() {\n  this.setState({\n    isShowDialog: false\n  });\n}'
      }, {
        name: 'onFormInit',
        description: '表单初始化事件',
        template: 'function onFormInit(_form) {\n  this.setState({\n    form: _form\n  });\n}'
      }, {
        name: 'onOpen',
        description: '弹窗打开事件(开发中)'
      }],
      style: true,
      className: true,
      loop: false
    },
    component: {
      isContainer: false,
      isMinimalRenderUnit: true,
      isModal: true
    }
  }
};
var snippets = [{
  title: '新增数据',
  screenshot: 'https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/lowcode/dialog',
  schema: {
    componentName: 'DataAddDialog',
    props: {
      btnText: '新增数据',
      btnType: 'primary',
      title: '新增数据',
      items: [{
        component: 'Input',
        title: '表单项',
        name: "input_" + (0, _utils.uuid)()
      }],
      visible: undefined
    }
  }
}];
var _default = exports["default"] = (0, _extends2["default"])({}, DataAddDialogMeta, {
  snippets: snippets
});